 package org.sky.system.wrapper;

 import org.sky.core.mp.support.BaseEntityWrapper;
 import org.sky.core.tool.constant.KdConstant;
 import org.sky.core.tool.node.ForestNodeMerger;
 import org.sky.core.tool.utils.BeanUtil;
 import org.sky.core.tool.utils.Func;
 import org.sky.system.cache.SysCache;
 import org.sky.system.pojo.entity.Role;
 import org.sky.system.pojo.vo.RoleVO;

 import java.util.List;
 import java.util.Objects;
 import java.util.stream.Collectors;

/**
 * 包装类,返回视图层所需的字段
 *
  */
public class RoleWrapper extends BaseEntityWrapper<Role, RoleVO> {

	public static RoleWrapper build() {
		return new RoleWrapper();
	}

	@Override
	public RoleVO entityVO(Role role) {
		RoleVO roleVO = Objects.requireNonNull(BeanUtil.copyProperties(role, RoleVO.class));
		if (Func.equals(role.getParentId(), KdConstant.TOP_PARENT_ID)) {
			roleVO.setParentName(KdConstant.TOP_PARENT_NAME);
		} else {
			Role parent = SysCache.getRole(role.getParentId());
			roleVO.setParentName(parent.getRoleName());
		}
		return roleVO;
	}


	public List<RoleVO> listNodeVO(List<Role> list) {
		List<RoleVO> collect = list.stream().map(this::entityVO).collect(Collectors.toList());
		return ForestNodeMerger.merge(collect);
	}

}
